function [theta,phi,psi,per_t,per_v] = Test_LDA(iter_max_test,test_visual,test_textual,alpha, beta, gamma,phi, psi,filtered_idx_v,filtered_idx_t )
D = length(test_visual);
disp(['Testing document size is ', num2str(D)]);
K = size(phi,1);
disp(['Number of topics for testing ', num2str(K)]);

T = size(psi,2);
C = size(phi,2);


tic;
disp('start initial testing process');
[M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,topic_v_d,topic_t_d] = initTrain(D,test_visual,test_textual, K,C,T, alpha,beta,gamma);
toc;
disp('initialzation for training completed.');

disp('start prediction process');
iter = 1;
iter_freq = 10;
differ_perplexity = 10^8;
thresh_diff_perplexity = 0.1;
per_all_last = differ_perplexity;
count =1;
while (iter <=iter_max_test)&&(differ_perplexity > thresh_diff_perplexity)
    if iter==1
        disp('pre_fitering')
        sum_zv = sum_zv - sum(M_K_C(:,filtered_idx_v),2); 
        M_K_C(:,filtered_idx_v) = 0;
        sum_zt = sum_zt - sum(N_K_T(:,filtered_idx_t),2); 
        N_K_T(:,filtered_idx_t) = 0;
        
        for d = 1:D
            current_dv = test_visual{d};
            current_dv_one_hot = zeros(1,size(M_K_C,2));
            current_dv_one_hot(current_dv)=1; %%%% unique words
            filtered_idx_one_hot = zeros(1,size(M_K_C,2));
            filtered_idx_one_hot(filtered_idx_v)=1;
            temp = current_dv_one_hot.*filtered_idx_one_hot;    
            matching = find(temp==1);
            [position,~,~] = find( current_dv == matching);
            corresponding_topics = topic_v_d{d}(position);
            corresponding_topics = sort(corresponding_topics);
            un_co_t = unique(corresponding_topics);
            for t = 1:length(un_co_t)
                M_D_K(d,un_co_t(t)) = M_D_K(d,un_co_t(t)) - length(find(corresponding_topics==un_co_t(t)));
            end
            current_dt = test_textual{d};
            current_dt_one_hot = zeros(1,size(N_K_T,2));
            current_dt_one_hot(current_dt)=1; %%%% unique words
            filtered_idx_one_hot = zeros(1,size(N_K_T,2));
            filtered_idx_one_hot(filtered_idx_t)=1;
            temp = current_dt_one_hot.*filtered_idx_one_hot;    
            matching = find(temp==1);
            [position,~,~] = find( current_dt == matching);
            corresponding_topics = topic_t_d{d}(position);
            corresponding_topics = sort(corresponding_topics);
            un_co_t = unique(corresponding_topics);
            for t = 1:length(un_co_t)
                N_D_K(d,un_co_t(t)) = N_D_K(d,un_co_t(t)) - length(find(corresponding_topics==un_co_t(t)));
            end
    
        end
        
        
    end
    disp(['iteration ',num2str(iter)]);
    tic;
    [M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,topic_v_d,topic_t_d] = prediction(phi, psi, D,K,M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,test_visual,test_textual,topic_v_d,topic_t_d,alpha,filtered_idx_v,filtered_idx_t);
    if(mod(iter,iter_freq)==1)
        [per_t(count),per_v(count),per_all] = Cal_perplexity(D,M_D_K,N_D_K,phi,psi,test_visual,test_textual,alpha,filtered_idx_v, filtered_idx_t);
        disp(['current textual words perplexity is ' num2str(per_t(count))]);
        disp(['current visual words perplexity is ' num2str(per_v(count))]);
        count=count+1;
        differ_perplexity = abs(per_all_last-per_all);
        per_all_last = per_all;
    end
    toc;
    iter = iter+1;
end
disp('test process completed.');

theta = findTheta(M_D_K,alpha);
phi = findPhi(M_K_C);
psi = findPsi(N_K_T);