function [M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,len_dv,len_dt,topic_v_d,topic_t_d] = initTrain(D,train_visual,train_textual, K,C,T, alpha,beta,gamma)




%%%%% counting matrix used in Gibbs sampling process. 
M_D_K = zeros(D,K); % count number of times that k'th visual topic appear in doc d. 
N_D_K = zeros(D,K); % count number of times that k'th textual topic appear in doc d. 

M_K_C = beta*ones(K,C); %%% count number of times that visual words c assigned to topic k.
N_K_T = gamma*ones(K,T); %%% count number of times that textual words k assigned to topic k.


sum_zv = beta*C*ones(K,1); %%% count total number of times that visual topic zv appesrs.
sum_zt  = gamma*T*ones(K,1); %%% count total number of times that textual topic zt appesrs.

%%% temporal variables
len_dv = zeros(D,1); %%% how many visual words in doc d;
len_dt = zeros(D,1); %%% how many textual words in doc d;
for d= 1:D
    len_dv(d) = length(train_visual{d});
    len_dt(d) = length(train_textual{d});
end
%%%
tic;
disp('start initilize topic for each word...');
[M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt,topic_v_d,topic_t_d] = initTopicLabel(D, K, train_visual, train_textual, len_dv,len_dt,M_D_K,N_D_K,M_K_C,N_K_T,sum_zv,sum_zt);
%topic_v_d,topic_t_d documents the corresponding topic for each word.... 
toc;
disp('topic initilization completed.');



end